package com.ruoyi.system.domain.visit.dr;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class VisitDrTaskCompanyExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public VisitDrTaskCompanyExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andTaskIdIsNull() {
            addCriterion("task_id is null");
            return (Criteria) this;
        }

        public Criteria andTaskIdIsNotNull() {
            addCriterion("task_id is not null");
            return (Criteria) this;
        }

        public Criteria andTaskIdEqualTo(String value) {
            addCriterion("task_id =", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdNotEqualTo(String value) {
            addCriterion("task_id <>", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdGreaterThan(String value) {
            addCriterion("task_id >", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdGreaterThanOrEqualTo(String value) {
            addCriterion("task_id >=", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdLessThan(String value) {
            addCriterion("task_id <", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdLessThanOrEqualTo(String value) {
            addCriterion("task_id <=", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdLike(String value) {
            addCriterion("task_id like", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdNotLike(String value) {
            addCriterion("task_id not like", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdIn(List<String> values) {
            addCriterion("task_id in", values, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdNotIn(List<String> values) {
            addCriterion("task_id not in", values, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdBetween(String value1, String value2) {
            addCriterion("task_id between", value1, value2, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdNotBetween(String value1, String value2) {
            addCriterion("task_id not between", value1, value2, "taskId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(String value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(String value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(String value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(String value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(String value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(String value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLike(String value) {
            addCriterion("company_id like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotLike(String value) {
            addCriterion("company_id not like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<String> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<String> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(String value1, String value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(String value1, String value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andAddTimeIsNull() {
            addCriterion("add_time is null");
            return (Criteria) this;
        }

        public Criteria andAddTimeIsNotNull() {
            addCriterion("add_time is not null");
            return (Criteria) this;
        }

        public Criteria andAddTimeEqualTo(String value) {
            addCriterion("add_time =", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeNotEqualTo(String value) {
            addCriterion("add_time <>", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeGreaterThan(String value) {
            addCriterion("add_time >", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeGreaterThanOrEqualTo(String value) {
            addCriterion("add_time >=", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeLessThan(String value) {
            addCriterion("add_time <", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeLessThanOrEqualTo(String value) {
            addCriterion("add_time <=", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeLike(String value) {
            addCriterion("add_time like", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeNotLike(String value) {
            addCriterion("add_time not like", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeIn(List<String> values) {
            addCriterion("add_time in", values, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeNotIn(List<String> values) {
            addCriterion("add_time not in", values, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeBetween(String value1, String value2) {
            addCriterion("add_time between", value1, value2, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeNotBetween(String value1, String value2) {
            addCriterion("add_time not between", value1, value2, "addTime");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIsNull() {
            addCriterion("extfield_one is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIsNotNull() {
            addCriterion("extfield_one is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneEqualTo(String value) {
            addCriterion("extfield_one =", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotEqualTo(String value) {
            addCriterion("extfield_one <>", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneGreaterThan(String value) {
            addCriterion("extfield_one >", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_one >=", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLessThan(String value) {
            addCriterion("extfield_one <", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLessThanOrEqualTo(String value) {
            addCriterion("extfield_one <=", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLike(String value) {
            addCriterion("extfield_one like", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotLike(String value) {
            addCriterion("extfield_one not like", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIn(List<String> values) {
            addCriterion("extfield_one in", values, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotIn(List<String> values) {
            addCriterion("extfield_one not in", values, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneBetween(String value1, String value2) {
            addCriterion("extfield_one between", value1, value2, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotBetween(String value1, String value2) {
            addCriterion("extfield_one not between", value1, value2, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIsNull() {
            addCriterion("extfield_two is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIsNotNull() {
            addCriterion("extfield_two is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoEqualTo(String value) {
            addCriterion("extfield_two =", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotEqualTo(String value) {
            addCriterion("extfield_two <>", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoGreaterThan(String value) {
            addCriterion("extfield_two >", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_two >=", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLessThan(String value) {
            addCriterion("extfield_two <", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLessThanOrEqualTo(String value) {
            addCriterion("extfield_two <=", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLike(String value) {
            addCriterion("extfield_two like", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotLike(String value) {
            addCriterion("extfield_two not like", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIn(List<String> values) {
            addCriterion("extfield_two in", values, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotIn(List<String> values) {
            addCriterion("extfield_two not in", values, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoBetween(String value1, String value2) {
            addCriterion("extfield_two between", value1, value2, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotBetween(String value1, String value2) {
            addCriterion("extfield_two not between", value1, value2, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIsNull() {
            addCriterion("extfield_three is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIsNotNull() {
            addCriterion("extfield_three is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeEqualTo(String value) {
            addCriterion("extfield_three =", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotEqualTo(String value) {
            addCriterion("extfield_three <>", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeGreaterThan(String value) {
            addCriterion("extfield_three >", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_three >=", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLessThan(String value) {
            addCriterion("extfield_three <", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLessThanOrEqualTo(String value) {
            addCriterion("extfield_three <=", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLike(String value) {
            addCriterion("extfield_three like", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotLike(String value) {
            addCriterion("extfield_three not like", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIn(List<String> values) {
            addCriterion("extfield_three in", values, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotIn(List<String> values) {
            addCriterion("extfield_three not in", values, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeBetween(String value1, String value2) {
            addCriterion("extfield_three between", value1, value2, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotBetween(String value1, String value2) {
            addCriterion("extfield_three not between", value1, value2, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIsNull() {
            addCriterion("extfield_four is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIsNotNull() {
            addCriterion("extfield_four is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourEqualTo(String value) {
            addCriterion("extfield_four =", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotEqualTo(String value) {
            addCriterion("extfield_four <>", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourGreaterThan(String value) {
            addCriterion("extfield_four >", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_four >=", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLessThan(String value) {
            addCriterion("extfield_four <", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLessThanOrEqualTo(String value) {
            addCriterion("extfield_four <=", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLike(String value) {
            addCriterion("extfield_four like", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotLike(String value) {
            addCriterion("extfield_four not like", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIn(List<String> values) {
            addCriterion("extfield_four in", values, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotIn(List<String> values) {
            addCriterion("extfield_four not in", values, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourBetween(String value1, String value2) {
            addCriterion("extfield_four between", value1, value2, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotBetween(String value1, String value2) {
            addCriterion("extfield_four not between", value1, value2, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIsNull() {
            addCriterion("extfield_five is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIsNotNull() {
            addCriterion("extfield_five is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveEqualTo(String value) {
            addCriterion("extfield_five =", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotEqualTo(String value) {
            addCriterion("extfield_five <>", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveGreaterThan(String value) {
            addCriterion("extfield_five >", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_five >=", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLessThan(String value) {
            addCriterion("extfield_five <", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLessThanOrEqualTo(String value) {
            addCriterion("extfield_five <=", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLike(String value) {
            addCriterion("extfield_five like", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotLike(String value) {
            addCriterion("extfield_five not like", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIn(List<String> values) {
            addCriterion("extfield_five in", values, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotIn(List<String> values) {
            addCriterion("extfield_five not in", values, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveBetween(String value1, String value2) {
            addCriterion("extfield_five between", value1, value2, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotBetween(String value1, String value2) {
            addCriterion("extfield_five not between", value1, value2, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixIsNull() {
            addCriterion("extfield_six is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixIsNotNull() {
            addCriterion("extfield_six is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixEqualTo(String value) {
            addCriterion("extfield_six =", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixNotEqualTo(String value) {
            addCriterion("extfield_six <>", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixGreaterThan(String value) {
            addCriterion("extfield_six >", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_six >=", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixLessThan(String value) {
            addCriterion("extfield_six <", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixLessThanOrEqualTo(String value) {
            addCriterion("extfield_six <=", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixLike(String value) {
            addCriterion("extfield_six like", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixNotLike(String value) {
            addCriterion("extfield_six not like", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixIn(List<String> values) {
            addCriterion("extfield_six in", values, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixNotIn(List<String> values) {
            addCriterion("extfield_six not in", values, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixBetween(String value1, String value2) {
            addCriterion("extfield_six between", value1, value2, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixNotBetween(String value1, String value2) {
            addCriterion("extfield_six not between", value1, value2, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenIsNull() {
            addCriterion("extfield_seven is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenIsNotNull() {
            addCriterion("extfield_seven is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenEqualTo(String value) {
            addCriterion("extfield_seven =", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenNotEqualTo(String value) {
            addCriterion("extfield_seven <>", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenGreaterThan(String value) {
            addCriterion("extfield_seven >", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_seven >=", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenLessThan(String value) {
            addCriterion("extfield_seven <", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenLessThanOrEqualTo(String value) {
            addCriterion("extfield_seven <=", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenLike(String value) {
            addCriterion("extfield_seven like", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenNotLike(String value) {
            addCriterion("extfield_seven not like", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenIn(List<String> values) {
            addCriterion("extfield_seven in", values, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenNotIn(List<String> values) {
            addCriterion("extfield_seven not in", values, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenBetween(String value1, String value2) {
            addCriterion("extfield_seven between", value1, value2, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenNotBetween(String value1, String value2) {
            addCriterion("extfield_seven not between", value1, value2, "extfieldSeven");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}